﻿using System.Collections;
using System.Collections.Generic;
using System.IO;
using System;
using UnityEngine;
using UnityEngine.Events;
using System.Globalization;


namespace Mod
{
    public class Mod : MonoBehaviour
    {
        public static void Main()
        {
            ModAPI.FindSpawnable("Human").Prefab.GetComponent<PersonBehaviour>().RandomisedSize = false; //this the line of code that disables the random sizes

            try
            {
                string vals = ModAPI.DeserialiseJSON<string>("IdentHuman_Heights.json");
                string[] epic = vals.Split(',');
                ModAPI.FindSpawnable("Human").Prefab.transform.localScale = new Vector3(Convert.ToSingle(epic[0]), Convert.ToSingle(epic[0]) );
                ModAPI.FindSpawnable("Android").Prefab.transform.localScale = new Vector3(Convert.ToSingle(epic[1]), Convert.ToSingle(epic[1]));
            }
            catch
            {
                ModAPI.FindSpawnable("Human").Prefab.transform.localScale = new Vector3(Convert.ToSingle(1), Convert.ToSingle(1));
                ModAPI.FindSpawnable("Android").Prefab.transform.localScale = new Vector3(Convert.ToSingle(1), Convert.ToSingle(1));
            }
            //StreamReader sr = new StreamReader("savedSizes.txt");
            //string hSize = sr.ReadLine();
            //string aSize = sr.ReadLine();

            //if (hSize != "")
            //{
            //    ModAPI.FindSpawnable("Human").Prefab.transform.localScale = new Vector3(Convert.ToSingle(hSize), Convert.ToSingle(hSize));
            //    humanSize = Convert.ToSingle(hSize);
            //}

            //if (aSize != "")
            //{
            //    ModAPI.FindSpawnable("Android").Prefab.transform.localScale = new Vector3(Convert.ToSingle(hSize), Convert.ToSingle(hSize));
            //    androidSize = Convert.ToSingle(aSize);
            //}

            //sr.Dispose();


            ModAPI.RegisterPower<SizeChange>(
                "Change Human Size",
                "Allows you to set the desired spawn size of humans.",
                ModAPI.LoadSprite("PowerThumb.png")
                );
            ModAPI.RegisterPower<SizeChangeAndroid>(
            "Change Android Size",
            "Allows you to set the desired spawn size of androids.",
            ModAPI.LoadSprite("PowerThumb2.png"),
            "Change Human Size"
            );

        }
    }
    public class SizeChange : ToolBehaviour
    {

        public void Start()
        {
            //try
            //{
            //    string vals = ModAPI.DeserialiseJSON<string>("IdentHuman_Heights.json");
            //    string[] epic = vals.Split('\n');
            //    ModAPI.Notify(epic[0]);
            //    ModAPI.Notify(epic[1]);
            //}
            //catch
            //{
            //    //Sizes.human = 1f;
            //}
            
        }
        public override void OnToolChosen()
        {
            DialogBox boxx = (DialogBox)null;
            //DialogButton buttons;
            {
                new DialogButton("Ok", true);
            };
            boxx = DialogBoxManager.TextEntry("Human Size", "1", new DialogButton[] { new DialogButton("Ok", true, (UnityAction)(() => Change(boxx))) });
            void Change(DialogBox dBox)
            {
                ModAPI.FindSpawnable("Human").Prefab.transform.localScale = new Vector3(Convert.ToSingle(dBox.EnteredText), Convert.ToSingle(dBox.EnteredText));
                try
                {
                    //ModAPI.Notify("first");
                    string vals = ModAPI.DeserialiseJSON<string>("IdentHuman_Heights.json");
                    //ModAPI.Notify("test");
                    //ModAPI.Notify(vals);
                    string[] epic = vals.Split(',');
                    //ModAPI.Notify(epic[0]);
                    //ModAPI.Notify(epic[1]);
                    ModAPI.SerialiseJSON(dBox.EnteredText + "," + epic[1], "IdentHuman_Heights.json");
                }
                catch
                {
                    ModAPI.SerialiseJSON(dBox.EnteredText + "," + 1, "IdentHuman_Heights.json");
                }
                //string hSize = sr.ReadLine();
                //string aSize = sr.ReadLine();
                //sr.Dispose();
                //Mod.humanSize = Convert.ToSingle(dBox.EnteredText)
                //System.IO.File.WriteAllText("savedSizes.txt", dBox.EnteredText + "\n" + aSize);
            }
        }
        public override void OnToolUnchosen()
        {
            //ModAPI.FindSpawnable("Human").Prefab.transform.localScale = new Vector3(humanSize, humanSize);
        }

        public override void OnSelect()
        {
            //Gets invoked when an object is selected while this tool is equipped
        }

        public override void OnHold()
        {
            //Gets invoked for every frame an object is held while this tool is equipped
        }

        public override void OnFixedHold()
        {
            //Gets invoked for every FixedUpdate an object is held while this tool is equipped
        }

        public override void OnDeselect()
        {
            //Gets invoked when an object is deselected while this tool is equipped
        }
    }

    public class SizeChangeAndroid : ToolBehaviour
    {
        public override void OnToolChosen()
        {
            DialogBox boxx = (DialogBox)null;
            //DialogButton buttons;
            {
                new DialogButton("Ok", true);
            };
            boxx = DialogBoxManager.TextEntry("Android Size", "1", new DialogButton[] { new DialogButton("Ok", true, (UnityAction)(() => Change(boxx))) });
            void Change(DialogBox dBox)
            {
                ModAPI.FindSpawnable("Android").Prefab.transform.localScale = new Vector3(Convert.ToSingle(dBox.EnteredText), Convert.ToSingle(dBox.EnteredText));
                try
                {
                    //ModAPI.Notify("first");
                    string vals = ModAPI.DeserialiseJSON<string>("IdentHuman_Heights.json");
                    //ModAPI.Notify("test");
                    //ModAPI.Notify(vals);
                    string[] epic = vals.Split(',');
                    //ModAPI.Notify(epic[0]);
                    //ModAPI.Notify(epic[1]);
                    ModAPI.SerialiseJSON(epic[0] + "," + dBox.EnteredText, "IdentHuman_Heights.json");
                }
                catch
                {
                    ModAPI.SerialiseJSON(1 + "," + dBox.EnteredText, "IdentHuman_Heights.json");
                }
            }
        }
        public override void OnToolUnchosen()
        {
            //ModAPI.FindSpawnable("Human").Prefab.transform.localScale = new Vector3(humanSize, humanSize);
        }

        public override void OnSelect()
        {
            //Gets invoked when an object is selected while this tool is equipped
        }

        public override void OnHold()
        {
            //Gets invoked for every frame an object is held while this tool is equipped
        }

        public override void OnFixedHold()
        {
            //Gets invoked for every FixedUpdate an object is held while this tool is equipped
        }

        public override void OnDeselect()
        {
            //Gets invoked when an object is deselected while this tool is equipped
        }
    }

}
// Originally uploaded by 'hankmart'. Do not reupload without their explicit permission.
